// This #include statement was automatically added by the Spark IDE.
#include "OneWire.h"
#include <math.h>

// This #include statement was automatically added by the Spark IDE.
#include "spark-dallas-temperature.h"

// -----------------
// Read temperature
// -----------------

// Data wire is plugged into port 0 on the Arduino
// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(D0);

// Pass our oneWire reference to Dallas Temperature.
DallasTemperature dallas(&oneWire);

// Create a variable that will store the temperature value
double temperature = 0.0;
double tempSet = 0.0;

// add a servo
int servoPin = D2;
Servo stove;
int servoPos = 0;
bool isTurn = false;




void setup(){
  // Register a Particle Core variable here
  Particle.variable("temperature", &temperature, DOUBLE);
  Particle.variable(  "servoPos" , &servoPos , INT );
  Particle.function("set", setTemperature);

  stove.attach(servoPin);

  // setup the library
  dallas.begin();

  Serial.begin(9600);

}

void loop(){
  // Request temperature conversion (traditional)
  dallas.requestTemperatures();

  // sin( 23423 );

  // get the temperature in Celcius
  float tempC = dallas.getTempCByIndex(0);
  // convert to double
  temperature = (double)tempC;

  // Print out
  Serial.print( "Temp in C = ");
  Serial.println( tempC );

  if (tempC != -127){
    if (tempC >= tempSet && isTurn == false){
      for (int i = 0; i < 180; i++) {
        stove.write(i);
        Serial.println(i);
        delay(80);
      }
      isTurn = true;
    } else if (tempC < tempSet) {
      servoControl("30");
      Serial.println("\t0!");
      isTurn = false;
    }
  }


  delay(5000);

}

int setTemperature(String targetTemp){
  tempSet = atof(targetTemp);
  return atoi(targetTemp);
}

int servoControl(String command){
  Serial.println("\n servo called");
   servoPos = constrain(command.toInt(), 0 , 180);
   stove.write(servoPos);
   return 1;
}

/*
The API request will look something like this:
GET /v1/devices/{DEVICE_ID}/temperature

# EXAMPLE REQUEST IN TERMINAL
# Core ID is 0123456789abcdef
# Your access token is 123412341234
curl -G https://api.particle.io/v1/devices/0123456789abcdef/temperature \
  -d access_token=123412341234
*/
